<!DOCTYPE html>
<html id="html" lang="de">
<head>
    <meta charset="UTF-8">
    <title>File- und Filesystem Forensik</title>
    <style>
        html {

            background-color: cornflowerblue;
        }
        body {
            font-size: larger;
            margin: 100px 20%  0 20%;
        }

        a, a:visited {
            color: black;
        }
        button {
            margin-top: 5px;
        }
    </style>
</head>
<body>
<div id="boom">
    <h1>Hallo Agent X</h1>

    <p>Unser Team konnte auf seiner letzten Mission eine Liste an dubiosen Transaktionen von international gesuchten Waffenhändlern bergen, doch ist diese Liste verschlüsselt.
        Wir brauchen den Zugang innerhalb von <bold>3 Stunden</bold>, sonst werden alle Spuren der Verdächtigen vernichtet.</p>
    <p>Wir vermuten den Schlüssel auf dem PC des Besitzers.</p>

    <p>Ihr Auftrag, falls Sie Ihn Annehmen. Suchen Sie den Schlüssel auf dem von uns gesicherten Teil der Festplatte und geben Sie den gefundenen Schlüssel unten ein.</br>
    Falls Sie oder Ihr Team versagen oder gefangen genommen werden, streiten wir jegliche Verbindung zu Ihnen oder Ihrem Team ab.
    </br>
    Viel Erfolg, Agent X!</p>

    <p>Nach Erhalt des Images zerstört sich diese Nachricht in <bold>3 Sekunden</bold> von selbst.</p>
    <p><a href="Secret.img" onclick="setTimeout(destroy, 3000)" download>Image</a></p>
</div>
<div>
    <input id="token"></br>
    <button onClick="checkToken()">Prüfen</button>
    <div id="answer"></div>
</div>
<script>

    function destroy()
    {
        let boom = document.getElementById("boom");
        document.getElementById("html").style.backgroundColor = "orangered";
        boom.innerHTML = "<h1>BOOM!!!!!</h1>";
    }

    async function checkToken(){
        console.log("checkToken");
        let token = document.getElementById("token").value;
        let answerField = document.getElementById("answer")
        if(await checkHash(token))
        {
            success(answerField);
        }else
        {
            failed(answerField);
        }
    }

    async function checkHash(token)
    {
        console.log("checkHash");
        let hashedToken = await sha256(token);
        return hashedToken === "06d2e328423a9d52a316ab569d1dea72b0a1a801fc95bedbd9a23b6568ce7db6";
    }

    function success(answerField)
    {
        console.log("Success");
        answerField.style.backgroundColor = "lawngreen";
        answerField.innerHTML = "<h1>Gut gemacht Agent X! Sie haben den richtigen Schlüssen gefunden. Die Welt kann dank Ihnen eine weitere Nacht ruhig schlafen!</h1>";
    }

    function failed(answerField)
    {
        console.log("Failed");
        answerField.style.backgroundColor = "red";
        answerField.innerHTML= "<h1>Das war wohl nichts Agent X! Solche Fehler dürfen Ihnen nicht passieren.</h1>";
    }

    async function sha256(message) {
        // encode as UTF-8
        const msgBuffer = new TextEncoder().encode(message);

        // hash the message
        const hashBuffer = await crypto.subtle.digest('SHA-256', msgBuffer);

        // convert ArrayBuffer to Array
        const hashArray = Array.from(new Uint8Array(hashBuffer));

        // convert bytes to hex string
        const hashHex = hashArray.map(b => b.toString(16).padStart(2, '0')).join('');
        return hashHex;
    }
</script>
</body>
</html>